Subject: Re: [PATCH net 2/4] sh_eth: Fix RX recovery on R-Car in case of RX ring underrun

From: Sergei Shtylyov <[email-masked]>
Date: Fri, 27 Feb 2015 23:20:35 +0300

Hello.

On 02/26/2015 05:19 PM, Ben Hutchings wrote:

> In case of RX ring underrun (RDE), we attempt to reset the software
> descriptor pointers (dirty_rx and cur_rx) to match where the hardware
> will read the next descriptor from, as that might not be the first
> dirty descriptor.  This relies on reading RDFAR, but that register
> doesn't exist on all supported chips - specifically, not on the R-Car
> chips.  This will result in unpredictable behaviour on those chips
> after an RDE.

> Make this pointer reset conditional and assume that it isn't needed on
> the R-Car chips.  This fix also assumes that RDFAR is never exposed at
> offset 0 in the memory map - this is currently true, and a subsequent
> commit will fix the ambiguity between offset 0 and no-offset in the
> register offset maps.

> Fixes: 79fba9f51755 ("net: sh_eth: fix the rxdesc pointer when rx ...")
> Signed-off-by: Ben Hutchings <[email-masked]>
> ---
> I was able to trigger RDE by adding a udelay(10) to the loop in
> sh_eth_rx() (limiting RX to <100,000 pps) and sending minimum size
> frames with pktgen (~160,000 pps at 100M).  The RDE was recorded in the
> netdev stats.  After the RDE and recover I could still pass traffic
> successfully so no extra code appears to be needed for this chip.

    Thank you for at last tackling this; it was on my agenda for a long time...

WBR, Sergei